// Caractéristique d'un dipôle
// Convertisseur courant tension
// SA1 -> tension aux bornes du dipôle
// EA0 = SA1
// EA1 = courant

path=get_absolute_file_path("caracteristiqueDipole.sce")
function [u,du,i,di]=acquerirPoint(r,tension)
    CanEcrire(1,tension,0,0)
    sleep(10000)
    ne=1000
    te=1.0e-4
    CanConfigEchantillon(te*1e6,ne)
    CanAcquerir()
    temps=CanTemps()
    tensions=CanEntrees()
    u=mean(tensions(1,:))
    du=st_deviation(tensions(1,:))
    i=-mean(tensions(2,:))/r
    di=st_deviation(tensions(1,:))
endfunction

CanOuvrir("SysamSP5")
CanEcrire(1,0.0,0,0)
sleep(10000)
CanConfigEntrees([0,1],[10,10])
r=0.1 // résistance du convertisseur courant-tension
np=100
umin=0
umax=-10
listeU=linspace(umin,umax,np)
liste_u=zeros(np,1)
liste_du=zeros(np,1)
liste_i=zeros(np,1)
liste_di=zeros(np,1)
scf()
xtitle('','I (mA)','u (V)')
xgrid(1)
for k=1:np
    [liste_u(k),liste_du(k),liste_i(k),liste_di(k)]=acquerirPoint(r,listeU(k))
    plot2d(liste_u(k),liste_i(k),rect=[0,-10/r,10,10/r],style=-4)
    errbar(liste_u(k),liste_i(k),liste_du(k),liste_di(k))
end
CanEcrire(1,0.0,0,0)
CanFermer()
csvWrite([liste_u,liste_du,liste_i,liste_di],path+"/lampe.csv")



